#python2.7.3
# coding: utf-8
import sys
import os.path
import struct
from struct import *
#-------------------------------------------------
#
argvs = sys.argv
argc = len(argvs)
if (argc != 3):
	print 'expample: # python %s test.bin 0x9000' % argvs[0]
	quit()

fn, ext = os.path.splitext(argvs[1])
infile = open(argvs[1],'rb')
indata = infile.read()
inlen = len(indata)
unpacked = unpack("B" * inlen, indata)
infile.close()

sadr = eval(argvs[2])
eadr = sadr + inlen - 1
if sadr > 0xFFFF:
	print 'address error.'
	quit()

# CLEAR 分の第二パラメータは、「BASIC が最大でもそのアドレスまで使用する」という意味。
# CLEAR ,&HB3FF ならば、機械語プログラムは 0xB400 以降に安全に配置できる。


s = ''
s += "100 REM Binary to N60-BASIC\n"
s += "110 CLEAR 300,&H{0:0>4X}\n".format(sadr-1)
s += "120 S=&H{0:0>4X}:E=&H{1:0>4X}\n".format(sadr, eadr)
s += '130 FOR A=S TO E:READ B$:POKE A,VAL("&H"+B$):NEXT\n'
s += "140 SCREEN 3,3,3:CLS:REM END\n"
s += "150 EXEC S:END\n"

LNUM = 160
LCNT = 0
LMAX = 16	 		# 一行に収める byte 数
POS = 0
while POS < inlen:
	if LCNT == 0:
		s += '{0} data '.format(LNUM)

	v = unpacked[POS]
	LCNT += 1

	s += '{0:0>2X}'.format(v)

	if LCNT >= LMAX:
		s += '\n'
		LCNT = 0
		LNUM += 10
	else:
		if POS<>inlen-1:
			s += ','
	POS += 1

#s += '\n-\n'	# Direct Statement Error を起こすためにゴミをいれる
s += '\n'

f = open(fn + '_bas.txt','w')
f.write(s)
f.close()
print 'done.'
#print s
